#include <iostream>
#include "global.h"
#include "heuristic.h"

using namespace std;

static int maxPrice;
static bool *bestSolution;
static unsigned long long step;

void bubbleSort(float *koefs, int *indexes, int n);
void innerSolve();

int heuristicRate(bool print) {
		bestSolution = new bool[n];
		for(int i = n-1; i >= 0; i--) {
				bestSolution[i] = false;
		}

		step = 0;
		innerSolve();

		if(print) printSolution(bestSolution, maxPrice, step);
		delete [] bestSolution;

		return maxPrice;
}

int heuristicTest(bool print) {
		bestSolution = new bool[n];
		for(int i = n-1; i >= 0; i--) {
				bestSolution[i] = false;
		}

		step = 0;
		innerSolve();

		int price = 0;
		for(int i = n-1; i >= 0; i--) {
				if(items[i][1] > maxPrice) {
						delete [] bestSolution;
						bestSolution = new bool[n];
						for(int j = n-1; j >= 0; j--) {
								bestSolution[j] = false;
						}
						bestSolution[i] = true;
						maxPrice = items[i][1];
				}
		}

		if(print) printSolution(bestSolution, maxPrice, step + n);

		delete [] bestSolution;
		return maxPrice;
}

void innerSolve() {
		float *koefs = new float[n];
		for(int i = n-1; i >= 0; i--) {
				koefs[i] = (float) items[i][0] / (float) items[i][1];
		}

		int *indexes = new int[n];
		for(int i = n-1; i >= 0; i--) {
				indexes[i] = i;
		}

		bubbleSort(koefs, indexes, n);
		
		delete [] koefs;

		int weight = 0;
		int i = 0;

		while((weight != maxWeight) && (i < n)) {
				if((weight + items[indexes[i]][0]) <= maxWeight) {
						bestSolution[indexes[i]] = true;
						weight += items[indexes[i]][0];
				}
				i++;
		}

		delete [] indexes;
		maxPrice = 0;
		for(int i = n-1; i >= 0; i--)
				if(bestSolution[i])
						maxPrice += items[i][1];
}

void bubbleSort(float *koefs, int *indexes, int n) {
		int i, j, temp, flag;

		for(i = n-1; i > 0; i--) {
				flag = 1;
				for(j = 0; i > j; j++) {
						if(koefs[indexes[j]] > koefs[indexes[j+1]]){
								flag = 0;
								temp = indexes[j];
								indexes[j] = indexes[j+1];
								indexes[j+1] = temp;
						}
						step++;
				}
				if(flag) break;
		}
}
